Gentoo Forums
Gentoo Forums
Gentoo Forums
Quick Search: in
Prelink doesn't do anything at all.
View unanswered posts
View posts from last 24 hours

 
Reply to topic    Gentoo Forums Forum Index Desktop Environments
View previous topic :: View next topic  
Author Message
fireboy1919
n00b
n00b


Joined: 28 May 2002
Posts: 47

PostPosted: Sun Jan 12, 2003 12:01 pm    Post subject: Prelink doesn't do anything at all. Reply with quote

No matter how I run it, I always get this result:

Code:
prelink: dso.c:306: fdopen_dso: Assertion `j == k' failed.
Aborted



I'm using binutils 2.13.90.0.16-r1, and libelf 0.8.2.

Here's an example of a minimal test (with this outcome)
First a summary:
ldd /usr/lib/phoenix/phoenix-bin
Code:
        libdl.so.2 => /lib/libdl.so.2 (0x4f769000)
        libmozjs.so => /usr/lib/mozilla/libmozjs.so (0x40016000)
        libxpcom.so => /usr/lib/mozilla/libxpcom.so (0x4008e000)
        libplds4.so => /usr/lib/mozilla/libplds4.so (0x40197000)
        libplc4.so => /usr/lib/mozilla/libplc4.so (0x4019a000)
        libnspr4.so => /usr/lib/mozilla/libnspr4.so (0x4019f000)
        libpthread.so.0 => /lib/libpthread.so.0 (0x4f875000)
        libgtk-1.2.so.0 => /usr/lib/libgtk-1.2.so.0 (0x4fa40000)
        libgdk-1.2.so.0 => /usr/lib/libgdk-1.2.so.0 (0x4fb7d000)
        libgmodule-1.2.so.0 => /usr/lib/libgmodule-1.2.so.0 (0x4f91d000)
        libglib-1.2.so.0 => /usr/lib/libglib-1.2.so.0 (0x4f8f5000)
        libXi.so.6 => /usr/X11R6/lib/libXi.so.6 (0x4f8eb000)
        libXext.so.6 => /usr/X11R6/lib/libXext.so.6 (0x4f852000)
        libX11.so.6 => /usr/X11R6/lib/libX11.so.6 (0x4f76e000)
        libm.so.6 => /lib/libm.so.6 (0x4f744000)
        libstdc++.so.5 => /usr/lib/gcc-lib/i686-pc-linux-gnu/3.2.1/libstdc++.so.5 (0x401cf000)
        libgcc_s.so.1 => /usr/lib/gcc-lib/i686-pc-linux-gnu/3.2.1/libgcc_s.so.1 (0x4029b000)
        libc.so.6 => /lib/libc.so.6 (0x4f612000)
        /lib/ld-linux.so.2 => /lib/ld-linux.so.2 (0x4f5fc000)


Then the actual run:
Code:
prelink /usr/lib/phoenix/phoenix-bin


The output, of course, is shown above.

I looked at dso.c from prelink's distrobution, but whoever coded it didn't do a very good job of commenting or using descriptive variables, so I couldn't very easily determine what went wrong.

I've tried many test, and this is always the result. How do I fix it? Or, for that matter, what does that mean?
Back to top
View user's profile Send private message
delta407
Bodhisattva
Bodhisattva


Joined: 23 Apr 2002
Posts: 2876
Location: Chicago, IL

PostPosted: Mon Jan 13, 2003 11:47 pm    Post subject: Re: Prelink doesn't do anything at all. Reply with quote

fireboy1919 wrote:
No matter how I run it, I always get this result:

Code:
prelink: dso.c:306: fdopen_dso: Assertion `j == k' failed.
Aborted
I also get this on at least three machines, all running the latest stable version of every package in Portage.
_________________
I don't believe in witty sigs.
Back to top
View user's profile Send private message
delta407
Bodhisattva
Bodhisattva


Joined: 23 Apr 2002
Posts: 2876
Location: Chicago, IL

PostPosted: Mon Jan 13, 2003 11:53 pm    Post subject: Reply with quote

Bug #13878 filed.
_________________
I don't believe in witty sigs.
Back to top
View user's profile Send private message
ebrostig
Bodhisattva
Bodhisattva


Joined: 20 Jul 2002
Posts: 3152
Location: Orlando, Fl

PostPosted: Mon Jan 13, 2003 11:56 pm    Post subject: Reply with quote

I'm not an expert on prelinking either, but I have a few questions:
1. Did you recompile and reinstall glibc after emerge'ing prelink?

2. Have you prelinked all your libraries?

3. What is the contents of (if I remember correct) /etc/prelink.conf?

4. What is the CFLAGS set to? (Does it include -fpic?)

Erik
_________________
'Yes, Firefox is indeed greater than women. Can women block pops up for you? No. Can Firefox show you naked women? Yes.'
Back to top
View user's profile Send private message
delta407
Bodhisattva
Bodhisattva


Joined: 23 Apr 2002
Posts: 2876
Location: Chicago, IL

PostPosted: Tue Jan 14, 2003 12:00 am    Post subject: Reply with quote

ebrostig wrote:
1. Did you recompile and reinstall glibc after emerge'ing prelink?
No, but neither `man prelink` nor the Gentoo prelink guide suggest that I should.

ebrostig wrote:
2. Have you prelinked all your libraries?
AFAIK, this is done by prelink during the run.

ebrostig wrote:
3. What is the contents of (if I remember correct) /etc/prelink.conf?
The default that the prelink ebuild ships with.

ebrostig wrote:
4. What is the CFLAGS set to? (Does it include -fpic?)
No, it does not, but if that was the problem prelink would complain about the library and move on rather than failing an assertion and terminating.
_________________
I don't believe in witty sigs.
Back to top
View user's profile Send private message
RickDB
Apprentice
Apprentice


Joined: 20 Sep 2002
Posts: 155
Location: Netherlands

PostPosted: Wed Jan 15, 2003 9:30 pm    Post subject: Reply with quote

After prelinking(everything according to the prelinking guide), my system is screwed.
Boot and shutdown problems, /proc/cmdline problem.
I did a prelink -uaf but that did not fix it :(
And today when i tried to update ut2003(had this problem before with prelink had to reinstall) i got this error:

Code:

Uncompressing Unreal Tournament 2003 for GNU/Linux 2126 patch.....................................................................
gzip: stdin: invalid compressed data--crc error

loki_patch: dynamic-link.h:57: elf_get_dynamic_info: Assertion `! "bad dynamic tag"' failed.
./update.sh: line 62: 30373 Aborted                 loki_patch --verify patch.dat
The program returned an error code (1)
Update failed

if i reboot now i think it won´t boot it did last time when this happened, so can someone plz tell me how to fix this(don´t want to reinstall again :( )?


*Edit* now my elfs seem to be on the lose:

root@localhost rick # prelink -uf ut2003
prelink: cannot open ELF file: no eror
root@localhost rick #
Back to top
View user's profile Send private message
floam
Veteran
Veteran


Joined: 27 Oct 2002
Posts: 1067
Location: Vancouver, WA USA

PostPosted: Thu Feb 06, 2003 2:26 am    Post subject: Reply with quote

the ut2003 problem you are getting is a problem with the updater. ryan gordan (the guy who ported ut2003) said on the mailing list some time back that the updater is not compatable with glibc 2.3, how ever it has been fixed in newer versions of ut2k3, so instead of using the updater download the tarball of the lates patch and extract it to /usr/local/games/ut2003 and it will be fixed.
Back to top
View user's profile Send private message
Display posts from previous:   
Reply to topic    Gentoo Forums Forum Index Desktop Environments All times are GMT
Page 1 of 1

 
Jump to:  
You cannot post new topics in this forum
You cannot reply to topics in this forum
You cannot edit your posts in this forum
You cannot delete your posts in this forum
You cannot vote in polls in this forum